<?php
	/******************************************************************************/
	//                                                                            //
	//                           InstantCMS v1.10.6                               //
	//                        http://www.instantcms.ru/                           //
	//                                                                            //
	//                   written by InstantCMS Team, 2007-2015                    //
	//                produced by InstantSoft, (www.instantsoft.ru)               //
	//                                                                            //
	//                        LICENSED BY GNU/GPL v2                              //
	//                                                                            //
	/******************************************************************************/
	
	class p_notice extends cmsPlugin {
		
		
		
		public function __construct(){
			
			// Информация о плагине
			$this->info['plugin']      = 'p_notice';
			$this->info['title']       = 'Уведомления о событиях на сайте';
			$this->info['description'] = 'Уведомляет пользователей о новых постах, записях на стене и комментариях.';
			$this->info['author']      = 'Ris';
			$this->info['version']     = '2.1';
			
			// Настройки по-умолчанию
			$this->config['LANG_POST_ADD']    = 1;
			$this->config['CLUB_ADD']   = 1;
			$this->config['WALL_ADD'] = 1;
			$this->config['WALL_CLUB_ADD'] = 1;
			$this->config['COMMENT_POST'] = 1;
			$this->config['COMMENT_BLOG'] = 1;
			$this->config['COMMENT_CLUB'] = 1;
			$this->config['COMMENT_REPLAY'] = 1;
			$this->config['CLUBS_MEMBERS_NOTICE'] = 1;
			
			// События, которые будут отлавливаться плагином
			$this->events[] = 'ADD_POST_DONE';
			$this->events[] = 'ADD_WALL';
			$this->events[] = 'ADD_COMMENT';
			
			parent::__construct();
			
		}
		
		// ==================================================================== //
		/**
			* Обработка событий
			* @param string $event
			* @param mixed $item
			* @return mixed
		*/
		public function execute($event='', $item=array()){
			
			switch ($event){
				case 'ADD_POST_DONE': $item = $this->eventPostNotice($item); break;
			}
			switch ($event){
				case 'ADD_WALL': $item = $this->eventWall($item); break;
			}
			switch ($event){
				case 'ADD_COMMENT': $item = $this->eventComment($item); break;
			}
			
			return $item;
			
		}
		
		// ==================================================================== //
		
		private function eventPostNotice($item) {
			
			//Получаем автора поста
			$author = cmsUser::getInstance($item['user_id']);
			$author_link = '<a href="/users/'.$author->login.'">'.$author->nickname.'</a>';
			
			//Получаем модель блогов
			cmsCore::loadModel('blogs');
			
			// Получаем блог, в котором создан пост
			$blog = cmsBlogs::getInstance()->getBlog($item['blog_id']);
			
			//Получаем модель клубов
			cmsCore::loadModel('clubs');
			
			$modelClubs = new cms_model_clubs();
			
			//Получаем клуб, в котором создан пост
			$club = $modelClubs->getClub($blog['user_id']);
			
			// Если пост не в клубах - уведомляем владельца блога
			if ($this->config['POST_ADD'] == 1 && $blog['owner'] == 'user' && $item['user_id'] != $blog['user_id']){
				
			cmsUser::sendMessage(USER_UPDATER, $blog['user_id'], 'Пользователь <b>'.$author_link.'</b> добавил новый пост <b>&laquo;<a href="'.$item['seolink'].'">'.$item['title'].'</a>&raquo;</b> в Вашем блоге <b>&laquo;<a href="/blogs/'.$blog['seolink'].'">'.$blog['title'].'</a>&raquo;</b>'); }
			
			// Если пост в клубе - уведомляем владельца клуба
			elseif ($this->config['CLUB_ADD'] == 1 && $blog['owner'] == 'club' && $item['user_id'] != $club['admin_id']) {
				
				cmsUser::sendMessage(USER_UPDATER, $club['admin_id'], 'Пользователь <b>'.$author_link.'</b> добавил новый пост <b>&laquo;<a href="'.$item['seolink'].'">'.$item['title'].'</a>&raquo;</b> в Вашем клубе <b>&laquo;<a href="/clubs/'.$club['id'].'_blog">'.$club['title'].'</a>&raquo;</b>'); 
			}
			
			// Если пост в клубе - уведомляем членов клуба
			if ($this->config['CLUB_ADD'] == 1 && $blog['owner'] == 'club' && $this->config['CLUBS_MEMBERS_NOTICE'] = 1) {
				
				//Получаем всех членов клуба
				$modelClubs->initClubMembers($club['id']);
				$clubMembers = $modelClubs->getClubMembersIds();
				
				//Удаляем автора записи из списка рассылки
				$user_key = array_search($item['user_id'], $clubMembers);
				if ($user_key !== false) { unset($clubMembers[$user_key]); }
				
				cmsUser::sendMessages(USER_UPDATER, $clubMembers, 'Пользователь <b>'.$author_link.'</b> добавил новый пост <b>&laquo;<a href="'.$item['seolink'].'">'.$item['title'].'</a>&raquo;</b> в клубе <b>&laquo;<a href="/clubs/'.$club['id'].'_blog">'.$club['title'].'</a>&raquo;</b>'); 
			}
			
			return $item;
			
		}
		
		// ==================================================================== //
		
		private function eventWall($item) {
			
			//Получаем автора записи
			$author = cmsUser::getInstance($item['user_id']);
			$author_link = '<a href="/users/'.$author->login.'">'.$author->nickname.'</a>';
			
			//Получаем модель клубов
			cmsCore::loadModel('clubs');
			
			$modelClubs = new cms_model_clubs();
			
			//Получаем клуб, на стене которого запись
			$club = $modelClubs->getClub($item['user_id']);
			
			// Если запись на стене пользователя - уведомляем пользователя
			if ($this->config['WALL_ADD'] == 1 && $item['usertype'] == 'users'  && $item['author_id'] != $item['user_id'] ){
				
				cmsUser::sendMessage(USER_UPDATER, $item['user_id'], 'Пользователь <b>'.$author_link.'</b> добавил новую запись <b>&laquo;'.$item['content'].'&raquo;</b> <a href="/users/'.$user->login.'">на Вашей стене</a>.'); 
			}
			
			// Если запись на стене клуба - уведомляем владельца клуба
			elseif ($this->config['WALL_CLUB_ADD'] == 1 && $item['usertype'] == 'clubs' && $item['author_id'] != $club['admin_id']) {
				
				cmsUser::sendMessage(USER_UPDATER, $club['admin_id'], 'Пользователь <b>'.$author_link.'</b> добавил новую запись <b>&laquo;'.$item['content'].'&raquo;</b> на стене Вашего клуба <b>&laquo;<a href="/clubs/'.$club['id'].'">'.$club['title'].'</a>&raquo;</b>'); 
			}
			
			// Если запись на стене клуба и включено уведомление - уведомляем членов клуба
			if ($this->config['WALL_CLUB_ADD'] == 1 && $this->config['CLUBS_MEMBERS_NOTICE'] == 1 && $item['usertype'] == 'clubs') {
				
				//Получаем всех членов клуба
				$modelClubs->initClubMembers($club['id']);
				$clubMembers = $modelClubs->getClubMembersIds();
				
				//Удаляем автора записи из списка рассылки
				$user_key = array_search($item['author_id'], $clubMembers);
				if ($user_key !== false) { unset($clubMembers[$user_key]); }
				
				
				cmsUser::sendMessages(USER_UPDATER, $clubMembers, 'Пользователь <b>'.$author_link.'</b> добавил новую запись <b>&laquo;'.$item['content'].'&raquo;</b> на стене клуба <b>&laquo;<a href="/clubs/'.$club['id'].'">'.$club['title'].'</a>&raquo;</b>'); 
			}
			
			return $item;
			
		}
		
		// ==================================================================== //
		
		private function eventComment($item) {
			
			
			
			//Получаем автора комментария
			$author = cmsUser::getInstance($item['user_id']);
			$author_link = '<a href="/users/'.$author->login.'">'.$author->nickname.'</a>';
			
			$inDb = cmsDatabase::getInstance();
			
			//Получаем пост в котором комментарий
			$post = $inDb->get_fields('cms_blog_posts', "id = {$item['target_id']}", 'id, user_id, blog_id, title');
			
			//Получаем блог в котором пост, к которому комментарий
			$blog = $inDb->get_fields('cms_blogs', "id = {$post['blog_id']}", 'id, user_id, title, seolink, owner');
			
			//Получаем родительский комментарий
			if (!empty($item['parent_id'])) {
				$parent_comment = $inDb->get_fields('cms_comments', "id = {$item['parent_id']}", 'id, user_id, target_link, content');
			}
			
			//Получаем id комментария
			$comm_id = $inDb->get_field('cms_comments', 1, 'MAX(id)') + 1;
			
			//Получаем модель клубов
			if ($blog['owner'] == 'club'){
				cmsCore::loadModel('clubs');
				
				$modelClubs = new cms_model_clubs();
				
				//Получаем клуб, к посту в блоге которого добавлен комментарий
				$club = $modelClubs->getClub($blog['user_id']);
			}
			
			// Уведомляем автора родительского комментария
			if ($this->config['COMMENT_REPLAY'] == 1 && !empty($item['parent_id']) && $item['user_id'] != $parent_comment['user_id']){
				
				cmsUser::sendMessage(USER_UPDATER, $parent_comment['user_id'], 'Пользователь <b>'.$author_link.'</b> ответил &laquo;<a href="'.$item['target_link'].'#c'.$comm_id.'">'.$item['content'].'</a>&raquo; на Ваш комментарий &laquo;<a href="'.$parent_comment['target_link'].'#c'.$parent_comment['id'].'">'.$parent_comment['content'].'</a>&raquo; .'); 
			}
			
			if ($item['target'] == 'blog' || $item['target'] == 'club_post'){
				// Уведомляем автора поста
				if ($this->config['COMMENT_POST'] == 1 && $item['user_id'] != $post['user_id'] && $post['user_id'] != $parent_comment['user_id']) {
					
					cmsUser::sendMessage(USER_UPDATER, $post['user_id'], 'Пользователь <b>'.$author_link.'</b> добавил новый комментарий &laquo;<a href="'.$item['target_link'].'#c'.$comm_id.'">'.$item['content'].'</a>&raquo; к Вашему посту &laquo;<a href="'.$item['target_link'].'">'.$post['title'].'</a>&raquo;.'); 
				}
				
				// Уведомляем владельца блога
				if ($this->config['COMMENT_BLOG'] == 1 && $blog['owner'] == 'user' && $item['user_id'] != $blog['user_id'] && $blog['user_id'] != $post['user_id'] && $blog['user_id'] != $parent_comment['user_id']){
					
					cmsUser::sendMessage(USER_UPDATER, $blog['user_id'], 'Пользователь <b>'.$author_link.'</b> добавил новый комментарий &laquo;<a href="'.$item['target_link'].'#c'.$comm_id.'">'.$item['content'].'</a>&raquo; к посту &laquo;<a href="'.$item['target_link'].'">'.$post['title'].'</a>&raquo; в Вашем блоге &laquo;<a href="'.$blog['seolink'].'">'.$blog['title'].'</a>&raquo;.'); 
				} 
				
				// Уведомляем владельца клуба
				if ($this->config['COMMENT_CLUB'] == 1 && $blog['owner'] == 'club'&& $item['user_id'] != $club['admin_id'] && $item['user_id'] != $post['user_id'] && $club['admin_id'] != $post['user_id'] && $club['admin_id'] != $parent_comment['user_id']){
					
					cmsUser::sendMessage(USER_UPDATER, $club['admin_id'], 'Пользователь <b>'.$author_link.'</b> добавил новый комментарий &laquo;<a href="'.$item['target_link'].'#c'.$comm_id.'">'.$item['content'].'</a>&raquo; к посту &laquo;<a href="'.$item['target_link'].'">'.$post['title'].'</a>&raquo; в Вашем клубе &laquo;'.$club['title'].'</a>&raquo;.'); 
				}
				
				// Уведомляем членов клуба
				if ($this->config['COMMENT_CLUB'] == 1 && $blog['owner'] == 'club' && $this->config['CLUBS_MEMBERS_NOTICE'] == 1 && $blog['owner'] == 'club'){
					
					//Получаем всех членов клуба
					$modelClubs->initClubMembers($club['id']);
					$clubMembers = $modelClubs->getClubMembersIds();
					
					//Удаляем автора комментария из списка рассылки
					$user_key = array_search($item['user_id'], $clubMembers);
					if ($user_key !== false) { unset($clubMembers[$user_key]); }
					
					//Удаляем автора поста из списка рассылки
					$user_key = array_search($post['user_id'], $clubMembers);
					if ($user_key !== false) { unset($clubMembers[$user_key]); }
					
					//Удаляем владельца блога из списка рассылки
					$user_key = array_search($blog['user_id'], $clubMembers);
					if ($user_key !== false) { unset($clubMembers[$user_key]); }
					
					cmsUser::sendMessages(USER_UPDATER, $clubMembers, 'Пользователь <b>'.$author_link.'</b> добавил новый комментарий &laquo;<a href="'.$item['target_link'].'#c'.$comm_id.'">'.$item['content'].'</a>&raquo; к посту &laquo;<a href="'.$item['target_link'].'">'.$post['title'].'</a>&raquo; в клубе &laquo;'.$club['title'].'</a>&raquo;.'); 
				}
				
				
				
			}
			
			return $item;
			
		}
		
		// ==================================================================== //
		
	}
